<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <div>
      <v-row justify="space-between" align="center">
        <v-col cols="1">
              <v-img width="80" v-if="providerData.driver=='openstack'" contain src="https://upload.wikimedia.org/wikipedia/commons/thumb/8/80/The_OpenStack_logo.svg/1024px-The_OpenStack_logo.svg.png"></v-img>
              <v-img width="80" v-else-if="providerData.driver=='vmware'" contain src="https://www.vmware.com/etc/clientlibs/vmwaredevapp/clientlib-nav-redesign/images/vm-logo.png"></v-img>
              <v-img width="80" v-else-if="providerData.driver=='ec2'" contain src="https://upload.wikimedia.org/wikipedia/commons/thumb/9/93/Amazon_Web_Services_Logo.svg/150px-Amazon_Web_Services_Logo.svg.png"></v-img>
              <v-img width="80" v-else-if="providerData.driver=='kubernetes'" contain src="https://upload.wikimedia.org/wikipedia/commons/3/39/Kubernetes_logo_without_workmark.svg"></v-img>
              <v-icon v-else large>mdi-cloud-outline</v-icon>
        </v-col>
        <v-col cols="7">
            <h2>
              {{providerData.name}}
            </h2>
        </v-col>
        <v-col cols="4">
            <v-card-actions>
              <v-spacer/>
              <v-btn small :disabled="!enabledActions.edit" @click="$emit('editProvider', providerData)">Edit</v-btn>
              <v-btn small :disabled="!enabledActions.clone" @click="$emit('cloneProvider', providerData)">Clone</v-btn>
              <v-btn small :disabled="!enabledActions.delete" v-on:click="dialog=true">Delete</v-btn>
            </v-card-actions>
        </v-col>
      </v-row>
    </div>

    <v-dialog v-model="dialog" max-width="500px"
    >
      <v-card>
        <v-card-title>
          <span>Delete provider</span>
        </v-card-title>
        <v-card-text>
        Are you sure that you want to permanently delete provider "{{providerData.name}}"?
        <br/><br/>
        This action cannot be reverted.
        </v-card-text>
        <v-card-actions>
          <v-spacer/>
          <v-btn @click="dialog = false">Cancel</v-btn>
          <v-btn class="primary" v-on:click="deleteProvider()">Delete</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <MessageBox
      :model="message"
      v-on:hide="message.show=false"
    />

    <CommonHeader
      :title="MSG.PR_GENERAL_SECTION_TITLE"
      :description="MSG.PR_GENERAL_SECTION_DESCRIPTION"
    />

    <v-container>
      <v-row dense>
        <v-col cols="6" >
          <div class="esy-label">Name</div> {{providerData.name}}
        </v-col>
        <v-col cols="6" >
          <div class="esy-label">ID</div> {{providerData.id}}
        </v-col>
      </v-row>
      <v-row v-if="providerData.description">
        <v-col cols="12">
          <div class="esy-label">Description</div> {{providerData.description}}
        </v-col>
      </v-row>
    </v-container>

    <template v-if="sharing!='shared'">

    <CommonHeader
      :title="MSG.PR_CONNECTION_SECTION_TITLE"
      :description="MSG.PR_CONNECTION_SECTION_DESCRIPTION"
    />

      <OpenStack
        v-if="providerData.driver=='openstack'"
        :provider="providerData"
      />
      <VMware
        v-if="providerData.driver=='vmware'"
        :provider="providerData"
      />
      <EC2
        v-if="providerData.driver=='ec2'"
        :provider="providerData"
      />
      <Kubernetes
        v-if="providerData.driver=='kubernetes'"
        :provider="providerData"
      />

      <template
        v-if="this.getCustomProperties().length>0"
      >
        <CommonHeader
          :subtitle="MSG.PR_CUSTOM_PROPS_SECTION_TITLE"
          :description="MSG.PR_CUSTOM_PROPS_SECTION_DESCRIPTION"
          :descriptionAsHint="false"
        />
        <KeyValues
          :entries="this.getCustomProperties()"
        />

      </template>

      <CommonHeader
        title="Service accounts"
        description="Default credentials (username/password) for the different VM images."
      />
      <div v-if="this.getServiceProperties().length>0">
        <KeyValues
          :entries="this.getServiceProperties()"
        />
      </div>
      <v-container v-else>
        No accounts provided (will use default ones)
      </v-container>

      <CommonHeader
        :title="MSG.PR_POST_CREATE_SCRIPTS_SECTION_TITLE"
        :description="MSG.PR_POST_CREATE_SCRIPTS_SECTION_DESCRIPTION"
      />
      <div v-if="providerData.service_properties && providerData.service_properties.post_create_script!=null && providerData.service_properties.post_create_script!= '{}' && Object.keys(providerData.service_properties.post_create_script).length>0">
        <KeyValues
          :entries="this.getPostCreateScripts()"
        />
      </div>
      <v-container v-else>
        No scripts provided
      </v-container>


    </template>

    <template v-if="false">

      <CommonHeader
        title="Sharing"
      />
      <v-container>

        <div v-if="sharing=='public'">
          <v-icon small>mdi-earth</v-icon> {{MSG.PR_PUBLIC}}
        </div>

        <div v-if="sharing=='private'">
          <v-icon small>mdi-lock</v-icon> {{MSG.PR_PRIVATE}}
        </div>

        <div v-if="sharing=='shared'">
          <v-icon small>mdi-share-variant</v-icon> {{MSG.PR_VISIBLETOME}}
        </div>

      </v-container>

      <CommonHeader
        title="Results"
      />
      <todo>links to grafana or embedded reports... or nothing</todo>

    </template>


  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import OpenStack from './viewers/OpenStack.vue';
import VMware from './viewers/VMware.vue';
import EC2 from './viewers/EC2.vue';
import Kubernetes from './viewers/Kubernetes.vue'
import KeyValues from '../common/KeyValues.vue';
import todo from '../common/ToDo.vue';
import MessageBox from '../common/MessageBox.vue';

import _getKnownProperties from './providers.js';

import { MESSAGES } from "../common/messages";

import { getProviderSharingLevel } from '../common/benchsuite.js';

export default {

 name: 'ProviderViewer',

 components: {
    CommonHeader,
    KeyValues,
    todo,
    MessageBox,
    EC2,
    Kubernetes,
    OpenStack,
    VMware
  },

  props: {
    providerId: {
      type: String,
      default: ''
    },
    provider: {
      type: Object,
      default: function() {return {}}
    }
  },

  data: () => ({
    MSG: MESSAGES,
    providerData : {grants:{}},
    dialog:false,
    message: {
      show: false,
      text: "",
      title: ""
    },
    enabledActions: {
      edit: false,
      clone: false,
      delete: false
    }
  }),

  created () {
    if(this.provider && this.provider.id) {
      this.providerData = this.provider;
    } else if(this.providerId) {
      this.$store.commit('fbkon')

      // get the provider
      this.$http
            .get(this.$REST_BASE_URL + '/providers/'+this.providerId)
        .then(response => {
          this.providerData = response.data
          this.$emit("title", this.providerData.name);
         }
        )
      .finally(() => {this.$store.commit('fbkoff')});

      // update actions
      this.$http
            .get(this.$REST_BASE_URL + '/providers/'+this.providerId+"/user_actions")
        .then(response => {
          this.enabledActions.edit = response.data.edit=="True";
          this.enabledActions.clone = response.data.clone=="True";
          this.enabledActions.delete = response.data.delete=="True";
        })
    }

  },

  mounted () {
    this.$vuetify.goTo(document.body, {duration:200})
  },

  computed: {
    sharing() {
      if(this.providerData.id)
        return getProviderSharingLevel(this.providerData);
      else
        return null;
    }
  },

  methods:{

   deleteProvider: function(){
    this.$store.commit('fbkon')
     this.$http.delete(this.$REST_BASE_URL + "/providers/"+this.providerData.id)
    .then(() => {
        this.providerData = null;
        this.$emit("providerDeleted")
      }
    )
    .catch(error => {
      if (error.response) {
        if(error.response.status==401) {
          this.message.title="Not authorized";
          this.message.text="You are not allowed to remove the provider.";
          this.message.show = true;
        }
      } else {
        console.log(error)
      }
    })
    .finally(() => {this.$store.commit('fbkoff'); this.dialog=false} );
   },


   getCustomProperties: function() {
     var knownProps = _getKnownProperties(this.providerData.driver);
     var out = [];
     for(var k in this.providerData) {
       if(!knownProps.includes(k) && this.providerData[k]) {
         out.push({"key":k, "value":this.providerData[k]});
       }
     }
     return out;
    },

    getPostCreateScripts: function() {

      if(!this.providerData || !this.providerData.service_properties || !this.providerData.service_properties.post_create_script)
        return []

      var scripts = this.providerData.service_properties.post_create_script

      var out = [];
      for(var k in scripts) {
        var level = this.getScriptLevel(k);
        var formatted = "<div class='command'>"+scripts[k].replace(/\n/g, '<br/>')+"</div>";
        out.push({key:k, value:scripts[k], formatted:formatted, weight:level, highlight:level>0, icon:"mdi-code-greater-than"});
      }

      // now sort them by weight, then by name
      out.sort(function(a, b){
        var res = b.weight-a.weight
        if(res!=0)
          return res;
        return b.key < a.key;
      })

      return out;
    },

    getServiceProperties: function() {

      if(!this.providerData || !this.providerData.service_properties || !this.providerData.service_properties.post_create_script)
        return []

      var out = [];
      var knownProps = ["vm_user", "vm_password"];
      for(var i in knownProps) {
        var prop = knownProps[i];
        var variants = this.providerData.service_properties[prop];
        if(variants) {
          for(var k in variants) {
            if(k=="default")
              out.push({key:prop, value:variants[k]});
            else
              out.push({key:prop+"_"+k, value:variants[k]});
          }
        }
      }


      // now sort them by weight, then by name
      out.sort(function(a, b){
        return b.key < a.key;
      })

      return out;
    },

    getScriptLevel: function(name) {
      var platforms = "(debian|centos|ubuntu)";
      var re = new RegExp("^"+platforms+"_[0-9\\.]+$", "g");
      if(name.match(re))
        return 3;
      re = new RegExp("^"+platforms+"$", "g");
      if(name.match(re))
        return 2;
      if(name=="default")
        return 1;
      return 0;
    }

  }

};

</script>

<style>
  div.esy-label {
    color:rgba(0, 0, 0, 0.6);
    font-size:12px;
  }
  div.esy-label-normal, span.esy-label-normal {
    color:rgba(0, 0, 0, 0.6);
  }

  div.command {
    overflow:auto;
    font-family:monospace;
    font-size:10pt;
    background:#404040;
    padding:10px;
    color:white
  }


</style>
